package be.iminds.ilabt.jfed.experimenter_gui.timeline.model;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.experiment.SshConnectionPoolFactory;
import be.iminds.ilabt.jfed.experimenter_gui.timeline.view.TimelineNodeFactory;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXModelRspec;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 12/8/2014
 * Time: 17:12
 */
@Singleton
public class TimelineModelFactory {

    @Nullable private final SshConnectionPoolFactory sshConnectionPoolFactory;
    @Nonnull private final TimelineNodeFactory timelineNodeFactory;

    @Inject
    public TimelineModelFactory(@Nullable SshConnectionPoolFactory sshConnectionPoolFactory, @Nonnull TimelineNodeFactory timelineNodeFactory) {
        this.sshConnectionPoolFactory = sshConnectionPoolFactory;

        this.timelineNodeFactory = timelineNodeFactory;
    }

    public TimelineModel createControllerModel(@Nonnull Experiment experiment) {
        if (sshConnectionPoolFactory == null) {
            throw new IllegalStateException("When creating a TimeLineModel with an experiment, the sshConnectionPoolFactory should be non-null");
        }
        return new TimelineModel(experiment, sshConnectionPoolFactory, timelineNodeFactory);
    }

    public TimelineModel createControllerModel(@Nonnull FXModelRspec modelRspec) {
        return new TimelineModel(modelRspec, timelineNodeFactory);
    }
}